/*
 * check for ncurses types, write sed commands to convert 
       ncurses.pas.in  to  ncurses.pas
   Note that this needs only the header file ncurses.h, not ncurses binary
     and not other source code.  inspired by gen.c in Ada95 ncurses library

 compile:   gcc ncp_gensed.c -o ncp_gensed
     run:   ./ncp_gensed  >ncp.sed
            sed -f ncp.sed ncurses.pas.in >ncurses.pas

 */

#include <ncurses.h>

int main(int argc GCC_UNUSED, char *argv[] GCC_UNUSED)
{
	
	{
	  const char* fmt  = "/@pas_typeof_chtype@/s//%s/\n";

	  if (sizeof(chtype)==sizeof(int)) {
	    if (sizeof(int)==sizeof(long))
	      printf(fmt,"MedCard");      /*  c type is unsigned long */
	    else
	      printf(fmt,"CCardinal");    /*  c type is unsigned int */
	  }
	  else if (sizeof(chtype)==sizeof(long)) {
	    printf(fmt,"MedCard");        /*  c type is unsigned long */
	  }
	  else
	    printf(" **  Error\n");

          printf("/@pas_widec_shift@/s//%d/\n", NCURSES_ATTR_SHIFT);  /* widec_shift = ATTR_SHIFT */

          printf("/@NCURSES_VERSION_MAJOR@/s//%d/\n", NCURSES_VERSION_MAJOR);
          printf("/@NCURSES_VERSION_MINOR@/s//%d/\n",NCURSES_VERSION_MINOR);
          printf("/@NCURSES_VERSION_PATCH@/s//%d/\n",NCURSES_VERSION_PATCH);
          printf("/@NCURSES_VERSION@/s//%d.%d/\n",NCURSES_VERSION_MAJOR,NCURSES_VERSION_MINOR);

       /* 
	  printf("define(`CF_CURSES_OK',`%d')\n",OK);
	  printf("define(`CF_CURSES_ERR',`%d')",ERR);
	  printf("define(`CF_CURSES_TRUE',`%d')",TRUE);
	  printf("define(`CF_CURSES_FALSE',`%d')",FALSE);
       */
	}

	
	return 0;  /*  EXIT_SUCCESS  */
}
